/* $Header: /cvsroot/sid/sid/user/c_tsw.c,v 1.21 2004/04/17 14:10:32 deppeler Exp $ */

#include "c_tsw.h"
#include "sha1_kernel.h"

/* globals - are these evil by nature? */
config_t	     *config; 
state_t		     *state;
int debug = 0;

int main (int argc, char **argv) {
	struct cmd_line_t 	*cmd_line_opts;

	config = (config_t *) ecalloc(1, sizeof(config_t));

	setprogname("tsw");

	cmd_line_opts = cmd_parse(argc, argv);
	debug = cmd_line_opts->debug;

	if ( cmd_line_opts->s == 1 ) {
		if ( gen_pass() != 0 )
			printf("error generating hash: contact the author to fix the source\n");
		exit(0);
	}

	read_config(cmd_line_opts);

	preprocess_time_spec(config);
	preprocess_syslog_spec(config);
	maint_pass(config);

	/* fork to background */
	if ( cmd_line_opts->debug == 0 ) {
		switch(fork()) {
			case -1:
				return (-1);
			case 0:
				if ( cmd_line_opts->q == 0 )
					printf("%s started.\n", progname());
				break;
			default:
				exit(0);
		}
	}

	if ( tail_on_file(config, state) < 0 ) {
		perror("Exiting\n");
		exit(2);
	}
	
	free_all(config);
	return 0;
}
